module AlchemyTask (solveAlchemyTask) where

import Vocabulary
import Data.Graph.AStar
import qualified Data.Set as S

nearbyStates st = 
  filter near vocabulary
  where
    near = (==1).sum.zipWith 
      (\a b -> if a == b then 0 else 1) st

alchemyHeuristic target st = 
    (foldl (\len (c1, c2) -> if c1 == c2 then len - 1 else len) 
     (length target) $ zip st target)

solveAlchemyTask :: String -> String -> [String]
solveAlchemyTask start goal =
  case rslt of
    Nothing -> []
    Just x -> x
  where
    rslt = aStar (S.fromList.nearbyStates)  (\_ _ -> 1) (alchemyHeuristic goal)
             (== goal) start
