{-# LANGUAGE ForeignFunctionInterface #-}
module AlchemyTaskWrap where

import AlchemyTask
import Foreign.C
import Foreign.Ptr
import Foreign.Marshal.Alloc
import Foreign.Marshal.Array

alchemyTaskSolve_hs :: CWString -> CWString -> IO (Ptr CWString)
alchemyTaskSolve_hs cwstart cwgoal = do
  start <- peekCWString cwstart
  goal <- peekCWString cwgoal
  let solution = solveAlchemyTask start goal
  ptrList <- mapM newCWString solution
  rslt <- newArray0 nullPtr ptrList
  return rslt

alchemyTaskFreeRslt_hs :: Ptr CWString -> IO ()
alchemyTaskFreeRslt_hs rslt = do
  ptrList <- peekArray0 nullPtr rslt
  mapM_ free ptrList
  free rslt
  return ()

foreign export ccall alchemyTaskSolve_hs :: CWString -> CWString -> IO (Ptr CWString)
foreign export ccall alchemyTaskFreeRslt_hs :: Ptr CWString -> IO ()

