#include "main.h" 
#include "gui.h" 
#include "AlchemyTaskWrap_stub.h"

IMPLEMENT_APP(SolverApp) 

class AppFrame: public SolverFrame {
  public:
    AppFrame( wxWindow* parent ) : SolverFrame(parent) { }

    void onSolveButtonClick( wxCommandEvent& event ) {
      wxString start = this->m_startText->GetValue();
      wxString goal = this->m_goalText->GetValue();
      if(start.Len() != 4 || goal.Len() != 4) {
        wxMessageBox(wxT("Invalid start or goal length!"));
        return;
      }
      wxTextCtrl* solText = this->m_solutionText;
      solText->Clear();

      HsPtr haskellSolution = alchemyTaskSolve_hs(
          static_cast<HsPtr>(const_cast<wxChar*>( start.c_str() )),
          static_cast<HsPtr>(const_cast<wxChar*>( goal.c_str() ))
        );

      wxChar** solution = static_cast<wxChar**>(haskellSolution);
      if(*solution == NULL) {
        wxMessageBox(wxT("No solution!"));
      } else {
        wxString solutionStr = start + wxT("\n"); 
        for(wxChar** curr = solution; *curr != NULL; curr++) {
          solutionStr += *curr;
          solutionStr += wxT("\n");
        }
        solText->SetValue(solutionStr);
      }

      alchemyTaskFreeRslt_hs(haskellSolution);
    }
};

bool SolverApp::OnInit() {
  int argc = 1;
  const char* prog_name = "main";
  char** argv = const_cast<char**>(&prog_name);
  hs_init(&argc, &argv); // does support unicode?

  AppFrame *frame = new AppFrame(NULL); 
  frame->Show(TRUE); 
  this->SetTopWindow(frame); 
  return TRUE; 
}

int SolverApp::OnExit() {
  hs_exit();
  return wxApp::OnExit();
}
